function keysTitle(key)
	if key == "escape" then
		lastview = view
		view = "confirm quit"
	end

	if key == "n" then
		view = "generation"
	end
end -- ending keysTitle

function keysGeneration(key)
	if genStep == 1 then
		if key == "return" then
			worldGenerationOcean()
			cameraSet()
			genStep = 2
		end
	end -- ending genStep 1 keys


	if genStep == 2 then
		if key == "m" then
			if overlayGenerationMenu == "on" then
				overlayGenerationMenu = "off"
			else overlayGenerationMenu = "on"
			end
		end

		if key == "e" then
			if overlayGenerationBorder == "on" then
				overlayGenerationBorder = "off"
			else overlayGenerationBorder = "on"
			end
		end
		
		if key == "p" then
			if overlayGenerationPalette == "on" then
				overlayGenerationPalette = "off"
			else overlayGenerationPalette = "on"
			end
		end	

		--if key == "c" then
		--	worldGenerationOcean() -- disabled until undo levels implemented
		--end

		if key == "g" then 
			worldGenerationFull()
		end

		if key == "b" then
			if brushSize == 1 then
				brushSize = 2
			elseif brushSize == 2 then
				brushSize = 1
			end
		end
	
		if key == "z" then
			if zoom == 0.5 then
				zoom = 1 
				mapfactor = 1
			else
				zoom = 0.5
				mapfactor = 2
			end
		end

		if key == "1" then
			brushCurrent = 1
		end

		if key == "2" then
			brushCurrent = 2
		end

		if key == "3" then
			brushCurrent = 3
		end

		if key == "4" then
			brushCurrent = 4
		end

		if key == "n" then
			local total = 0 -- initialize/clear the variable
			for rowIndex, row in ipairs(worldMap) do
				for columnIndex, quad in ipairs(row) do
					if quad ~= 1 then
						total = total + 1 -- increase total for every non-ocean title
					end
				end
			end
			if total > 3 then -- if there at least this many non-ocean tiles then allow next step
				if overlayGenerationStep3Confirm == "off" then
					overlayGenerationStep3Confirm = "on"
				else overlayGenerationStep3Confirm = "off"
				end
			end
		end

		if key == "y" then
			if overlayGenerationStep3Confirm == "on" then
				populationMapGeneration()
				seedPopulation()
				genStep = 3
			end
		end

		if zoom == 1 then -- beginning zoom scroll keys

			if key == "left" then
				if cam.x > 1 then
					cam.x = cam.x - 1
				end
			end

			if key == "right" then
				if cam.x <= 25  then
					cam.x = cam.x + 1
				end
			end

			if key == "up" then
				if cam.y > 1 then
					cam.y = cam.y - 1
				end
			end

			if key == "down" then
				if cam.y <= 25  then
					cam.y = cam.y + 1
				end
			end

		end -- ending zoom scroll keys
	
		if key == "escape" then
			love.event.push("quit")
		end
	end -- ending genStep 2 keys


	if genStep == 3 then -- beginning genStep 3 keys
		if key == "escape" then
			love.event.push("quit")
		end
	
		if key == "r" then
			population = {}
			populationMap = {}
			populationMapGeneration()
			seedPopulation()
		end
		if key == "z" then
			if zoom == 0.5 then
				zoom = 1 
				mapfactor = 1
			else
				zoom = 0.5
				mapfactor = 2
			end
		end

		if key == "right" then
			if popdisplay < #population then
			popdisplay = popdisplay + 1
			end
		end
		if key == "left" then
			if popdisplay > 1 then
			popdisplay = popdisplay - 1
			end
		end
		--[[
		if key == "3" then
			popdisplay = 3
		end
		if key == "4" then
			popdisplay = 4
		end
		--]]

	end -- ending genStep 3 keys
		
end -- ending keysGeneration

function mouseGeneration()

	if love.mouse.isDown("l") then
			local x, y = love.mouse.getPosition()
			local mouseYtile = math.floor(y / (tileH * zoom)) + 1 
			local mouseXtile = math.floor(x / (tileW * zoom)) + 1
			if zoom == 1 then
				mouseYtile = mouseYtile + (cam.y - 1)
				mouseXtile = mouseXtile + (cam.x - 1)
			end 
			if brushSize == 1 then
				if worldMap[mouseYtile][mouseXtile] < 4 then
					worldMap[mouseYtile][mouseXtile] = brushCurrent
				end
			elseif brushSize == 2 then
					for ycount = 0,1 do
						if worldMap[mouseYtile + ycount] then
							for xcount = 0,1 do
								if worldMap[mouseYtile + ycount][mouseXtile + xcount] then
									worldMap[mouseYtile + ycount][mouseXtile + xcount] = brushCurrent
								end
							end
						end
					end
			end
		end
end

function keysQuit(key)
	if key == "y" then
		love.event.push("quit")
	end

	if key == "n" then
		view = lastview
		lastview = nil
	end
end -- ending keysQuit
