
genStep = 1

worldSize = 50
worldMap = { }
baseMap = { }

zoom = 0.5
mapfactor = 2

overlayGenerationMenu = "on"
overlayGenerationBorder = "off"
overlayGenerationPalette = "on"
overlayPaintCursor = "on"

overlayGenerationStep3Confirm = "off"

brushSize = 1
brushCurrent = 1

popdisplay = 1

calendarDate = 1
calendarYear = 1
calendarRaw = 1

function worldGenerationOcean()
	for y = 1, worldSize do
		worldMap[y] = {}            
		for x = 1, worldSize do
			worldMap[y][x] = 1
		end
	end
	baseMap = worldMap
end


function worldGenerationFull()
	
	worldGenerationOcean() -- reset to ocean

	-- this is bad! temporary world generation only
	plainsShapes = { }
	plainsShapesCount = math.random(45,50)
	pso = { }	

	for i = 1,plainsShapesCount do
		--if plainsCurrentTiles > 0 then
		--	plainsShapesCount[i] = math.random(plainsCurrentTiles)
		--	plainsCurrentTiles = plainsCurrentTiles - plainsShapesCount[i]
			plainsShapes[i] =  2 --math.random(2) -- 1 is rectangle, 2 is triangle, 3 is circle
			pso[i] = {}
			pso[i].y = math.random(-5,worldSize)  
			pso[i].x = math.random(-5,worldSize) 
		--end
	end

	-- draw the plains shapes

	for i,shape in ipairs(plainsShapes) do
			local origin = pso[i] 
			count = 0
			local ymin = math.random(5)
			local ymax = math.random(8,10)
				for ycount = ymin,ymax do
					if worldMap[origin.y + ycount] then
						local xmin = math.random(8,10)
						local xmax = math.random(8,10)
						for xcount = -xmin,xmax do -- original: -(count),count do 
							if worldMap[origin.y + ycount][origin.x + xcount] then
								if ycount == ymin or ycount == ymax then 
									if math.random(1000) > 300 then
										worldMap[origin.y + ycount][origin.x + xcount] = 2
									end
								else
									worldMap[origin.y + ycount][origin.x + xcount] = 2
								end
							end
						end
					end
				count = count + 1
				end
		
	end -- ending plains drawing

end 
             
cam = {x = 1, y = 1}

camera = { }
popcamera = { }

function cameraSet()

	cameraSize = 25 * mapfactor

	for y = 1, cameraSize do
		camera[y] = {}            
		for x = 1, cameraSize do
			if mapfactor == 1 then
				camera[y][x] = worldMap[(y - 1) + cam.y][(x - 1) + cam.x]
			else
				camera[y][x] = worldMap[y][x]
			end
		end
	end

	if genStep == 3 then
		for y = 1, cameraSize do
			popcamera[y] = {}            
			for x = 1, cameraSize do
				if mapfactor == 1 then
					popcamera[y][x] = populationMapView[(y - 1) + cam.y][(x - 1) + cam.x]
				else
					popcamera[y][x] = populationMapView[y][x]
				end
			end
		end
	end
end

function viewGeneration()


	if genStep == 1 then
		love.graphics.print("Press [ENTER/RETURN] to generate a new blank world.",250,300)
		quadload()
	end -- ending genStep 1

	if genStep == 2 then

		love.graphics.push()
			love.graphics.scale(zoom,zoom)	
			for rowIndex, row in ipairs(camera) do
				for columnIndex, quadID in ipairs(row) do
					local x = (columnIndex - 1) * tileW
					local y = (rowIndex - 1) * tileH
					love.graphics.drawq(tileset,quads1[quadID],x,y)
				end
			end
		love.graphics.pop()

		if overlayPaintCursor == "on" then
			local drawCursorX, drawCursorY = love.mouse.getPosition()
			local zoomtileW = math.floor(drawCursorX / (tileW * zoom)) * (tileW * zoom)
			local zoomtileH = math.floor(drawCursorY / (tileH * zoom)) * (tileH * zoom)
			if brushSize == 1 or brushSize == 2 then  -- could do * brushSize but then "fill" becomes issue.. maybe use an brushSize == 1 OR == 2??
				love.graphics.rectangle("line", zoomtileW, zoomtileH, tileW * zoom * brushSize, tileH * zoom * brushSize)
			end
		end

		if overlayGenerationBorder == "on" then
			for i = 1,25 do -- draw the border
				local x = (i - 1) * tileW
				local y = (i - 1) * tileH
				love.graphics.draw(border,x,0)
				love.graphics.draw(border,x,792)
				love.graphics.draw(border,8,y,math.rad(90))
				love.graphics.draw(border,800,y,math.rad(90))
			end	
		
	
			if zoom == 1 then -- why does this need to go to 26?
				love.graphics.draw(cursor, 0, (cam.y-1) * (800-32) / 25)
				love.graphics.draw(cursor, cam.x * (800-32) / 25, 792, math.rad(90))
			end
		end -- ending border

		if overlayGenerationMenu == "on" then
			love.graphics.setColor(0,0,0,100)
			love.graphics.rectangle("fill",0,0,300,350)
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("line",0,0,300,350)
			
			love.graphics.setColor(255,255,255)
			love.graphics.print("LEFT BUTTON: place tile",10,30)
			love.graphics.print("1 - 4: select brush",10,60)
			love.graphics.print("B: set brush size (x1/x2/fill)",10,90)
			love.graphics.print("Z: set zoom (x1/x2)",10,120)
			love.graphics.print("G: generate a region",10,150)

			--love.graphics.print("C: clear the map",10,150) -- disabled for now; need to consider accidental use / undo levels
			--love.graphics.print("U: undo",10,170)

			love.graphics.print("P: hide/reveal palette",10,180)
			love.graphics.print("E: hide/reveal border",10,210)
			love.graphics.print("M: hide/reveal this menu",10,240)

			love.graphics.print("N: next step",10,320)
		end

		if overlayGenerationPalette == "on" then
			love.graphics.setColor(200,100,50)
			love.graphics.rectangle("fill",630,750,180,50)
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("line",630,750,180,50)
			love.graphics.setColor(255,255,255)
			
			for quadID = 1,4 do
				love.graphics.drawq(tileset,quads1[quadID],600 + (quadID * 40),759)
			end

			love.graphics.rectangle("line",600 + (brushCurrent * 40), 759, 33, 33)
		end -- ending palette

		if overlayGenerationStep3Confirm == "on" then
			love.graphics.setColor(100,100,100)
			love.graphics.rectangle("fill",200,380,400,50)
			love.graphics.setColor(255,255,255)
			love.graphics.printf("Are you sure you're ready to continue? Y / N",0,400,800,"center")
		end

	end -- ending genStep 2


	if genStep == 3 or genStep == 4 then

		love.graphics.push()
			love.graphics.scale(zoom,zoom)	
			for rowIndex, row in ipairs(camera) do
				for columnIndex, quadID in ipairs(row) do
					local x = (columnIndex - 1) * tileW
					local y = (rowIndex - 1) * tileH
					love.graphics.drawq(tileset,quads1[quadID],x,y)
				end
			end

			for rowIndex, row in ipairs(popcamera) do
				for columnIndex, quadID in ipairs(row) do
					local x = (columnIndex - 1) * tileW
					local y = (rowIndex - 1) * tileH
					love.graphics.drawq(settlements,quads2[quadID],x,y)
				end
			end
		love.graphics.pop()

		--[[
		local range = 1 + ((popdisplay - 1) * 50)
		love.graphics.print(range,750,20)
		love.graphics.print(#population,750,10) -- how many people do we have?
		for i = range,range + 49 do
			--for i,v in ipairs(population) do
				love.graphics.print(i,0,0 + (i * 15) % 751)
				love.graphics.print(population[i].sex,50,0 + (i * 15) % 751)
				love.graphics.print(population[i].age,120,0 + (i * 15) % 751)
				if population[i].parents[1] ~= "norec" then
					love.graphics.print(population[i].parents[1],150,0 + (i * 15) % 751)
					love.graphics.print(population[i].parents[2],200,0 + (i * 15) % 751)
				end
				love.graphics.print(population[i].location[1],350,0 + (i * 15) % 751)
				love.graphics.print(population[i].location[2],390,0 + (i * 15) % 751)
			--end
		end
		--]]

		if overlayPaintCursor == "on" then
			local drawCursorX, drawCursorY = love.mouse.getPosition()
			local zoomtileW = math.floor(drawCursorX / (tileW * zoom)) * (tileW * zoom)
			local zoomtileH = math.floor(drawCursorY / (tileH * zoom)) * (tileH * zoom)
			if brushSize == 1 or brushSize == 2 then  -- could do * brushSize but then "fill" becomes issue.. maybe use an brushSize == 1 OR == 2??
				love.graphics.rectangle("line", zoomtileW, zoomtileH, tileW * zoom * brushSize, tileH * zoom * brushSize)
			end
		end

		local mousex, mousey = love.mouse.getPosition()
		local mouseYtile = math.floor(mousey / (tileH * zoom)) + 1 
		local mouseXtile = math.floor(mousex / (tileW * zoom)) + 1


		if #populationMapData[mouseYtile][mouseXtile] > 0 then
			--for count = 1, #populationMapData[mouseYtile][mouseXtile] do
				local count = 0
				for popID, person in ipairs(populationMapData[mouseYtile][mouseXtile]) do
					count = count + 1
					love.graphics.print(populationMapData[mouseYtile][mouseXtile][popID], 0, 0 + (15 * (count-1)))
					love.graphics.print(population[person].nameFirst, 100, 0 + (15 * (count - 1))) 
					love.graphics.print(population[person].nameFamily, 200, 0 + (15 * (count - 1))) 
				end
			--end
		end

		love.graphics.print(popdisplay, 450, 10)
		love.graphics.print(population[popdisplay].nameFirst, 500, 10)
		love.graphics.print(population[popdisplay].nameFamily, 600, 10)

		--[[for rowIndex, row in ipairs(populationMapData) do
			for columnIndex, tile in ipairs(row) do
				for popID, person in ipairs(tile) do
					love.graphics.print
--]]
	end -- ending genStep 3

end -- ending viewGeneration()


